<?php
// +-----------------------------------------------------------------------+
// | Mod Name : Download_multi                                             |
// | Mod Version : 0.3                                                     |
// | Mod Orignal author: Tboris                                            |
// | Mod Second author : Cestlodovic                                       |
// | Mod Version author : FlipFlip <flipflip@free.fr>                      |
// | Mod description :                                                     |
// | Ce module est bas sur le module existant pour le tlchargement,     |
// | cette version permet le tlchargement sur plusieurs pages.           |
// | Mod Addon : PclZip -> http://www.phpconcept.net/pclzip/               |
// +-----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or modify  |
// | it under the terms of the GNU General Public License as published by  |
// | the Free Software Foundation                                          |
// |                                                                       |
// | This program is distributed in the hope that it will be useful, but   |
// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
// | General Public License for more details.                              |
// |                                                                       |
// | You should have received a copy of the GNU General Public License     |
// | along with this program; if not, write to the Free Software           |
// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
// | USA.                                                                  |
// +-----------------------------------------------------------------------+

//--------------------------------------------------------------------- include
define('PHPWG_ROOT_PATH', '../../');
include_once( PHPWG_ROOT_PATH.'include/common.inc.php' );

// Test de cration du rpertoire zip_archive
if(!is_dir($_SERVER['DOCUMENT_ROOT'].'/'.$conf['mod_dl_multi_rep_pwg'].'modules/download_multi/zip_archive/'))
{
    if(!mkdir($_SERVER['DOCUMENT_ROOT'].'/'.$conf['mod_dl_multi_rep_pwg'].'modules/download_multi/zip_archive/'))
    {
        echo '<div style="background-color: Red; font-size: 20px; text-align: center;">'."\n";
        echo $lang['dl_test_dir'].'<br>';
        echo '<a href="http://'.$_SERVER['HTTP_HOST'].'/'.$conf['mod_dl_multi_rep_pwg'].$cat.'">Retour</a>'."\n";
        echo '</div>';
        die();
    }
}

if(!isset($_GET['dl_act']))
{
    die('Hacking attempt!');
}
else
{
    $act = $_GET['dl_act']; // Rcupration de l'action  effectuer
}

// contrle si l'id utilisateur est envoy par l'url ou alors par le formulaire
// si c'est par le formulaire, cela veut dire que c'est un ajout de photos dans la base
// si c'est par l'url cela veut dire que c'est la suppression des images par
// rapport  id_user
if(isset($_POST['id_user']))
{
    $id_user = $_POST['id_user'];
    $cat = $_POST['cat'];
}
else
{
    $id_user = $_GET['id_user'];
    $cat = $_GET['cat'];
}

// Test de l'activation de javascript
if(isset($_POST['test_jv']))
{
    $test_jv = $_POST['test_jv'];
}

if(isset($_GET['test_jv']))
{
    $test_jv = $_GET['test_jv'];
}

if($test_jv != 1)
{
    echo '<div style="background-color: Red; font-size: 20px; text-align: center;">'."\n";
    echo $lang['dl_test_jv_01'].'<br>';
    echo '<a href="http://'.$_SERVER['HTTP_HOST'].'/'.$conf['mod_dl_multi_rep_pwg'].$cat.'">Retour</a>'."\n";
    echo '</div>';
    die();
}
// Fin du test javascript

// si le mode (type) d'image est prcis alors
// on rcupere les valeurs  utiliser.
if(isset($_POST['mode']))
{
    // Rcupration de la liste des images  copier
    // Rcupration du type de l'image  tlcharger
    $mode = $_POST['mode'];
    $images = $_POST['nom']; // Rcupration du chemin de l'image
}

switch($act)
{
    case 'add':
        switch($mode)
        {
            case 'thumbnail':
            // Insertion des vignettes dans la base de donnes
            for($i=0;$i<count($images);$i++)
            {
                // Rcupration du rpertoire de stockage de l'image
                $path = dirname($images[$i]);

                // Rcupration du nom du fichier image
                $fic = basename($images[$i]);

                // Recomposition du chemin d'accs en tenant compte du type d'image
                $fic_insert = '../../'.$path.'/thumbnail/'.$conf['prefix_thumbnail'].$fic;

                $query = '
                    INSERT INTO '.MOD_DOWNLOAD_MULTI.' (id_user, path) 
                    VALUES(\''.$id_user.'\', \''.$fic_insert.'\')
                ;';
                $result = pwg_query($query);
            }
            break;

            case 'normal':
                // Insertion des photos normal dans la base de donnes
                for($i=0;$i<count($images);$i++)
                {
                    // Rcupration du rpertoire de stockage de l'image
                    $path = dirname($images[$i]);

                    // Rcupration du nom du fichier image
                    $fic = basename($images[$i]);

                    // Recomposition du chemin d'accs en tenant compte du type d'image
                    $fic_insert = '../../'.$path.'/'.$fic;

                    $query = '
                        INSERT INTO '.MOD_DOWNLOAD_MULTI.' (id_user, path)
                        VALUES(\''.$id_user.'\', \''.$fic_insert.'\')
                    ;';
                    $result = pwg_query($query);
                }
            break;

            case 'hight':
                // Insertion des haut dfinition dans la base de donnes
                for($i=0;$i<count($images);$i++)
                {
                    // Rcupration du rpertoire de stockage de l'image
                    $path = dirname($images[$i]);

                    // Rcupration du nom du fichier image
                    $fic = basename($images[$i]);

                    // Recomposition du chemin d'accs en tenant compte du type d'image
                    $fic_insert = '../../'.$path.'/pwg_high/'.$fic;

                    // contrle si le fichier existe, dans le cas contraire
                    // rien n'est insr et le traitement continue sur les images suivantes.
                    if(file_exists($fic_insert))
                    {
                        $query = '
                            INSERT INTO '.MOD_DOWNLOAD_MULTI.' (id_user, path)
                            VALUES(\''.$id_user.'\', \''.$fic_insert.'\')
                        ;';
                        $result = pwg_query($query);
                    }
                }
            break;
        }
        // Modifier phpwebgallery si ncessaire :
        // Voir parametre $conf['mod_dl_multi_rep'] dans votre config_local.inc.php
        $url = 'http://'.$_SERVER['HTTP_HOST'].'/'.$conf['mod_dl_multi_rep_pwg'].$cat;
        redirect( $url );
    break;

    case 'trash':
        // Suppression des images slectionn dans une prcdente session
        $query = '
            DELETE FROM '.MOD_DOWNLOAD_MULTI.' 
            WHERE id_user = \''.$id_user.'\'
        ;';
        $result = pwg_query($query);

        $query = '
            OPTIMIZE TABLE `phpwebgallery_download_multi`
        ;';
        $result = pwg_query($query);

        // Modifier phpwebgallery si ncessaire :
        // Voir parametre $conf['mod_dl_multi_rep_pwg'] dans votre config_local.inc.php
        $url = 'http://'.$_SERVER['HTTP_HOST'].'/'.$conf['mod_dl_multi_rep_pwg'].$cat;
        redirect( $url );
    break;

    case 'down':
        // Selection des photos par rapport  l'id utilisateur
        $query = '
            SELECT path FROM '.MOD_DOWNLOAD_MULTI.' 
            WHERE id_user = '.$id_user.'
        ;';
        $result = pwg_query($query);

        // Si le nombre d'enregistrement est gale 
        // 0, alors il n'y a pas de fichier propos au tlchargement
        if (mysql_num_rows($result) == 0)
        {
            $url = 'http://'.$_SERVER['HTTP_HOST'].'/'.$conf['mod_dl_multi_rep_pwg'].$cat;
            redirect( $url );
        }
        else
        {
            require('pclzip.lib.php'); // inclusion de la librairie pour la compression zip
            $dir_zip = $_SERVER['DOCUMENT_ROOT'].'/'.$conf['mod_dl_multi_rep_pwg'].'modules/download_multi/zip_archive/';

            $id_file = rand(1, 2000);
            $nom_fichier = 'photos'.$id_file.'.zip'; // nom du fichier zip
            $fichier_zip = $dir_zip.$nom_fichier; // chemin d'accs au fichier zip
            $archive = new PclZip($fichier_zip);

            header('Content-type: application/force-download');
            header('Content-Disposition: attachment; filename='.$nom_fichier);

            while ($row = mysql_fetch_array($result))
            {
                $v_list = $archive->add($row['path'],
                                            PCLZIP_OPT_REMOVE_PATH, '../..',
                                            PCLZIP_OPT_COMMENT, $conf['mod_dl_multi_comment']
                                        );
                if ($v_list == 0)
                {
                    die('Erreur : '.$archive->errorInfo(true));
                }
            }
            // Suppression des valeurs pour ne pas tre  nouveau
            // tlcharger dans une session suivante
            $query = '
                DELETE FROM '.MOD_DOWNLOAD_MULTI.'
                WHERE id_user = \''.$id_user.'\'
            ;';
            $result = pwg_query($query);

            $query = '
                OPTIMIZE TABLE `phpwebgallery_download_multi`
            ;';

            $result = pwg_query($query);
            readfile($fichier_zip);
            unlink($fichier_zip);
        }
    break;
}
?>